var flags
var pre_pos = 0;
var loadData = {
	video: [],
	audio: []
};
var codecs = [];
var first = true;
var baseUrl = urlBackend;
var second = false;
var haveAudio = false;
var sourceBuffer;
var sourceBufferAud;
var video = document.querySelector('video');
var ws = new WebSocket(baseUrl);
ws.binaryType = 'arraybuffer';
var demux_moov = function (info) {
	for (let i = 0; i < info.tracks.length; i++) {
		codecs.push(info.tracks[i].codec);
	}
}
if (!window.MediaSource) {
	console.error('No Media Source API available');
}
var ms = new MediaSource();
video.src = window.URL.createObjectURL(ms);
ms.addEventListener('sourceopen', onMediaSourceOpen);

function onMediaSourceOpen() {
	video.buffered.start = 0;
	video.currentTime = 0;
	ws.onmessage = (e) => {
		//-----------------------------------------------------------------------
		/*
			Смотрим первые пакеты и определяем есть звук в потоке или нет, а так же 
			инициализируем буфферы, которые будут 
		*/
		if (first) {
			getCodecsStream(e.data)
			let mimeCodek
			let view = new Uint8Array(e.data)
			let needed = new Uint8Array([3])
			if (isArraysEqual(view.slice(143, 144), needed)) {
				flags = true;
				mimeCodek = ('video/mp4; codecs="' + codecs.join(', ') + '"');
				second = false;
			} else {
				flags = false;
				mimeCodek = 'video/mp4; codecs="' + codecs[0] + '"';
				second = true;
			}


			sourceBuffer = ms.addSourceBuffer(mimeCodek);
			sourceBuffer.mode = "sequence";
			loadData["video"].push(e.data);
			first = false;

			if (video.autoplay) {
				ws.send("play");
			}
			return;
		} else {
			if (second) {
				let view = new Uint8Array(e.data)
				let needed = new Uint8Array([102, 116, 121, 112])
				if (isArraysEqual(view.slice(4, 8), needed)) {
					getCodecsStream(e.data)
					let mimeCodekAud = 'audio/mp4; codecs="' + codecs[1] + '"';
					sourceBufferAud = ms.addSourceBuffer(mimeCodekAud);
					sourceBufferAud.mode = "sequence";
					loadData["audio"].push(e.data);
					second = false;
					haveAudio = true;
					return;
				}
				second = false;
			}
			// -------------------------------------------------------------------
			/*
				Блок определения вида пакета, в зависимости от того какой track ID 
				присваиваем его пайлоад к нужному слайсу
			*/
			let view = new Uint8Array(e.data)
			if (flags) {
				loadData["video"].push(view.buffer);
			} else {
				if (view[47] == 1) {
					loadData["video"].push(view.buffer);
				} else if (view[47] == 2) {
					loadData["audio"].push(view.buffer);
				}
			}

			//-------------------------------------------------------------------
			/*
				В зависимости от типа наполняем буфферы
			*/
			for (type in loadData) {
				if (type == "video" && loadData[type].length >= 1) {
					if (!sourceBuffer || sourceBuffer.updating) {
						continue;
					}
					if (loadData[type].length == 1) {
						sourceBuffer.appendBuffer(loadData[type].shift())
						continue;
					}
					let byte_length = 0;
					for (const qnode of loadData[type]) {
						byte_length += qnode.byteLength;
					}
					let mp4buf = new Uint8Array(byte_length);
					let offset = 0;
					for (const qnode of loadData[type]) {
						let frame = new Uint8Array(qnode);
						mp4buf.set(frame, offset);
						offset += qnode.byteLength;
					}
					sourceBuffer.appendBuffer(mp4buf);
					loadData[type].splice(0, loadData[type].length);
				}
				if (type == "audio" && loadData[type].length >= 1) {
					if (!sourceBufferAud || sourceBufferAud.updating) {
						continue;
					}
					if (loadData[type].length == 1) {
						sourceBufferAud.appendBuffer(loadData[type].shift())
						continue;
					}
					let byte_length = 0;
					for (const qnode of loadData[type]) {
						byte_length += qnode.byteLength;
					}
					let mp4buf = new Uint8Array(byte_length);
					let offset = 0;
					for (const qnode of loadData[type]) {
						let frame = new Uint8Array(qnode);
						mp4buf.set(frame, offset);
						offset += qnode.byteLength;
					}
					sourceBufferAud.appendBuffer(mp4buf);
					loadData[type].splice(0, loadData[type].length);
				}
			}
		}
		//----------------------------------------------------------------------
		/* 
			По итогу этот блок нужен для того чтобы в случае ошибок в соединении (маленьких 1-2 пакета)
			можно было пропустить и встать на тот таймлайн где данные есть и дальше воспроизводить буффер
		*/
		sourceBuffer.onupdateend = function (e) {
			let pos = video.currentTime;
			if (video.buffered.length > 0) {
				let start = video.buffered.start(video.buffered.length - 1);
				let end = video.buffered.end(video.buffered.length - 1);
				if (pos < start) {
					video.currentTime = start;
				}
				if (pos > end) {
					video.currentTime = start;
				}
				if (pos - pre_pos != 0 && end - pos > 1) {
					video.currentTime = end;
				}
				for (let i = 0; i < video.buffered.length - 1; i++) {
					let prestart = video.buffered.start(i);
					let preend = video.buffered.end(i);
					if (!sourceBuffer.updating) {
						sourceBuffer.remove(prestart, preend);
						if (haveAudio === true && !sourceBufferAud.updating) {
							sourceBufferAud.remove(prestart, preend);
						}
					}
				}
				if (pos - start > 10 && !sourceBuffer.updating) {
					sourceBuffer.remove(0, pos - 3);
					if (haveAudio === true && !sourceBufferAud.updating) {
						sourceBufferAud.remove(0, pos - 3);
					}
				}
				if (end - pos > 10 && !sourceBuffer.updating) {
					sourceBuffer.remove(0, end - 3);
					if (haveAudio === true && !sourceBufferAud.updating) {
						sourceBufferAud.remove(0, end - 3);
					}
				}
			}
			pre_pos = pos;
		};
	};
};


function wsClose() {
	if (ws.readyState = 1) {
		ws.send("pause")
	}
	let preview = document.getElementById("preview")
	document.getElementById("media-control-live").style.display = "none"
	preview.style.display = "block"
}

function raloadPage() {
	let preview = document.getElementById("preview")
	document.getElementById("media-control-live").style.display = "block"
	preview.style.display = "none"
	ws.send("play")
	video.play()
}

function isArraysEqual(firstArray, secondArray) {
	return firstArray.toString() === secondArray.toString();
}

function getCodecsStream(data) {
	let moov = data;
	let mp4Box = new MP4Box;
	mp4Box.onReady = demux_moov;
	moov.fileStart = 0;
	mp4Box.appendBuffer(moov);
}

function mute() {
	let mut = document.getElementById('mute');
	let unmut = document.getElementById('unMute');
	unmut.style.display = "block";
	mut.style.display = "none";
	editVolume(1)
	video.volume = 0;
}

function unMute() {
	let mut = document.getElementById('mute');
	let unmut = document.getElementById('unMute');
	unmut.style.display = "none";
	mut.style.display = "block";
	editVolume(10)
}
let fullscreen;
let fsEnter = document.getElementById('fullscr');
let fSsvg = document.getElementById('fScreen');
let sSsvg = document.getElementById('sScreen');
fsEnter.addEventListener('click', function (e) {
	e.preventDefault();
	if (!fullscreen) {
		fullscreen = true;
		document.documentElement.requestFullscreen();
		fSsvg.style.display = "block";
		sSsvg.style.display = "none";
	} else {
		fullscreen = false;
		document.exitFullscreen();
		fSsvg.style.display = "none";
		sSsvg.style.display = "block";
	}
});
document.addEventListener("fullscreenchange", function () {
	if ((window.fullScreen) || (window.innerWidth == screen.width && window.innerHeight == screen.height)) {
		fullscreen = true;
	} else {
		fullscreen = false;
	}
});

function editVolume(num) {
	video.muted = false;
	let vlEnter = document.getElementById('v' + num)
	if (vlEnter.className == "segmented-bar-element") {
		for (let i = 1; i <= num; i++) {
			let vpEnter = document.getElementById('v' + i);
			vpEnter.className = "segmented-bar-element fill";
		}
		video.volume = 0.1 * num
	} else {
		for (let i = num; i < 11; i++) {
			let vpEnter = document.getElementById('v' + i);
			vpEnter.className = "segmented-bar-element"
		}
		video.volume = 0.1 * num
	}
}

function startPage() {
	mute();
	editVolume(1);
	video.volume = 0;
	if (!video.autoplay) {
		let preview = document.getElementById("preview")
		document.getElementById("media-control-live").style.display = "none"
		preview.style.display = "block"
	}
}